// SPDX-License-Identifier: MPL-2.0
//! # DBus interface proxies for: `org.freedesktop.NetworkManager.Device.Statistics`
//!
//! This code was generated by `zbus-xmlgen` `2.0.0` from DBus introspection data.
//! Source: `Interface '/org/freedesktop/NetworkManager/Devices/3' from service 'org.freedesktop.NetworkManager' on system bus`.
//!
//! You may prefer to adapt it, instead of using it verbatim.
//!
//! More information can be found in the
//! [Writing a client proxy](https://dbus.pages.freedesktop.org/zbus/client.html)
//! section of the zbus documentation.
//!
//! This DBus object implements
//! [standard DBus interfaces](https://dbus.freedesktop.org/doc/dbus-specification.html),
//! (`org.freedesktop.DBus.*`) for which the following zbus proxies can be used:
//!
//! * [`zbus::fdo::PropertiesProxy`]
//! * [`zbus::fdo::IntrospectableProxy`]
//! * [`zbus::fdo::PeerProxy`]
//!
//! …consequently `zbus-xmlgen` did not generate code for the above interfaces.

use zbus::proxy;

#[proxy(
	interface = "org.freedesktop.NetworkManager.Device.Statistics",
	default_service = "org.freedesktop.NetworkManager"
)]
pub trait Statistics {
	/// RefreshRateMs property
	#[zbus(property)]
	fn refresh_rate_ms(&self) -> zbus::Result<u32>;
	#[zbus(property)]
	fn set_refresh_rate_ms(&self, value: u32) -> zbus::Result<()>;

	/// RxBytes property
	#[zbus(property)]
	fn rx_bytes(&self) -> zbus::Result<u64>;

	/// TxBytes property
	#[zbus(property)]
	fn tx_bytes(&self) -> zbus::Result<u64>;
}
